#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>

#include <unistd.h>
#include <fstream>
#include <dirent.h>
#include <cstdlib>
#include <ctime> 
#include <string>

/*=============================================================================

usage: $rand0mizer fileToRandomize dirWithFilesToChooseFrom

this application isn't very robust, it has to be executed in a working directory
where fileToRandomize and dirWithFilesToChoseFrom are located.

=============================================================================*/

using namespace std;

int batterycharge(void)
{
	int devbatt;
	unsigned short currentval=0;
	devbatt = open("/dev/batt", O_RDONLY);
	read (devbatt, &currentval, 2);
	close (devbatt);
	return (currentval);
}

int main(int argc, char *argv[]) 
{
	ofstream targetFile;
	ifstream randChosenFile;
	char* originalFileName = argv[1];
	char* directoryArg = argv[2];
	char randChosenFileName[320];
	DIR* sourceOfRandChosenFile;
	int randomInteger;
	struct  dirent  *dptr;

	//GRAB THE ARGUMENTS
	if(argc < 2)
	{
		printf("proper usage: $rand0mizer fileToRandomize dirWithFilesToChooseFrom\n");
		return -1;
	}

	//DELETE A FILE
	//unlink example @ http://www.scit.wlv.ac.uk/~jphb/spos/notes/calls/unlink.html
	if( unlink(originalFileName) == -1) //failed
	{
		printf("couldn't delete %s \n", originalFileName);
		return -1;
	}

	//RANDOMLY SELECT A FILE
        if( (sourceOfRandChosenFile = opendir(directoryArg)) == NULL)
        {
                printf("Error opening directory: %s \n", directoryArg);
        }

	//how many files to choose from?
	int numberOfFilesToChooseFrom =0;
        while( (dptr = readdir(sourceOfRandChosenFile)) )
        {
		//printf("%s\n",dptr->d_name);
		numberOfFilesToChooseFrom++;
        }
	numberOfFilesToChooseFrom = numberOfFilesToChooseFrom-2; //never pick the . or the .. 
			//the while loop counts one to many files but thats ok cuz modulo on rand? hmm

        //pick a file
	int count =0;
	int battNab =0;
	while( count < 7)
	{
		battNab = battNab + batterycharge();
		count ++;
	}
	srand( battNab );
	randomInteger = rand()%numberOfFilesToChooseFrom;

	//go to file file
	rewinddir(sourceOfRandChosenFile);
	readdir(sourceOfRandChosenFile); //gets .
	readdir(sourceOfRandChosenFile); //gets ..
	dptr = readdir(sourceOfRandChosenFile); //gets first file
	int i = 0;
	while( i != randomInteger )
	{
		dptr = readdir(sourceOfRandChosenFile);
		i++;
	}

	//build the file name to hit
	strcpy (randChosenFileName,"./");
	strcat (randChosenFileName, directoryArg);
	strcat (randChosenFileName,"/");
	strcat (randChosenFileName,dptr->d_name);
	printf("randChosenFileName: %s \n", randChosenFileName);
	
	//COPY A FILE
	//the link() system call isn't used because linking isn't allowed on fat32 file systems
	targetFile.open(originalFileName, ios::binary);
	randChosenFile.open(randChosenFileName, ios::binary|ios::ate); //open @ EOF for tellg
	if ( targetFile.is_open() && randChosenFile.is_open() ) 
	{
		ifstream::pos_type size;
		char * memblock;

		//fill the buffer
		size = randChosenFile.tellg();
		memblock = new char [size];
		randChosenFile.seekg (0, ios::beg);
		randChosenFile.read (memblock, size);
		randChosenFile.close();
		
		//squirt the buffer
		targetFile.write(memblock, size);
		targetFile.close();
		
		//kill the buffer
		delete[] memblock;
	}
	else
		printf("couldn't open randChosenFile or targetFile \n");

	return 0;
}
